# Mise en oeuvre d'un terminal X sans disque dur

### Jerry Kendall

`<jerry@kcis.com>`

Copyright © 1996 Jerry Kendall

28 Décembre 1996

Avec l'aide de quelques amis de la liste de diffusion pour les discussions techniques sur FreeBSD, j'ai pu mettre en service un terminal X sans disque dur. Pour cela, j'ai d'abord dû installer une station sans disque qui dispose d'un minimum d'utilitaires montés par NFS. J'ai répété l'opération pour disposer de deux systèmes sans disque. Pour les deux, j'ai procédé de la même façon. Le premier est `altair.kcis.com`. C'est un terminal X sur mon vieux 386DX-40. Il a bien un disque dur de 340 Mo, mais je ne voulais pas y toucher. Il démarre donc à partir de `antares.kcis.com` sur le réseau Ethernet. Le second est un 486DX2-66. J'ai installé un système FreeBSD (complet) qui n'utilise pas de disque local. Le serveur de démarrage est un Sun 670MP sous SunOs 4.1.3. Les deux systèmes FreeBSD sont configurés de la même façon.

Je suis sûr qu'il y a des choses à ajouter à ce document. Faites-moi s'il vous plaît part de vos commentaires.

La redistribution du code source (SGML), modifié ou non, et compilé (HTML, PostScript, etc.) est soumise aux conditions suivantes :

1. Le copyright ci-dessus, la présente liste de conditions et l'avertissement qui la suit doivent figurer dans le code source.

2. Le code source distribué sous forme compilée doit faire apparaître le copyright ci-dessus, la présente liste de conditions et l'avertissement qui la suit.

CE DOCUMENT EST FOURNI ``TEL QU'EN L'ÉTAT'' PAR LE PROJET DE DOCUMENTATION FRANÇAISE DE FreeBSD ET IL N'EST DONNÉ AUCUNE GARANTIE, IMPLICITE OU EXPLICITE, QUANT À SON UTILISATION COMMERCIALE, PROFESSIONNELLE OU AUTRE. LES COLLABORATEURS DU PROJET DE DOCUMENTATION FRANÇAISE DE FreeBSD NE PEUVENT EN AUCUN CAS ÊTRE TENUS POUR RESPONSABLES DE QUELQUE DOMMAGE OU PRÉJUDICE DIRECT, INDIRECT, SECONDAIRE OU ACCESSOIRE (Y COMPRIS LES PERTES FINANCIèRES DUES AU MANQUE À GAGNER, À L'INTERRUPTION D'ACTIVITÉS, OU LA PERTE D'INFORMATIONS ET AUTRES) DÉCOULANT DE L'UTILISATION DE LA DOCUMENTATION OU DE L'IMPOSSIBILITÉ D'UTILISER CELLE-CI, ET DONT L'UTILISATEUR ACCEPTE L'ENTIÈRE RESPONSABILITÉ.

Version française de Frédéric Haby `<frederic.haby@mail.dotcom.fr>`.

[ Multiples pages HTML / Page HTML unique ]

## 1. Préparation de la disquette de démarrage (sur le système sans disque)

Les gestionnaires de démarrage via le réseau ne sont pas compatibles avec les TSRs et autres qu'utilise MS-DOS, il est préférable de préparer une disquette de démarrage, ou, si vous le pouvez, de mettre en place un menu MS-DOS qui (par l'intermédiaire des fichiers `config.sys`/`autoexec.bat`) vous demande au démarrage quelle configuration charger. C'est cette dernière méthode que j'ai utilisée et elle fonctionne à merveille. Voici mon menu MS-DOS :

Exemple 1. `config.sys`

    [menu]
    menuitem=normal, normal
    menuitem=unix, unix
    [normal]
    ....
    config.sys habituel
    ...
    [unix]

Exemple 2. `autoexec.bat`

    @ECHO OFF
    goto %config%

    :normal
    ...
    autoexec.bat habituel
    ...
    goto end

    :unix
    cd \netboot
    nb8390.com

    :end

## 2. Générer les programmes de démarrage en réseau (sur le serveur)

Compilez les programmes de ``démarrage en réseau'' que vous trouverez dans `/usr/src/sys/i386/boot/netboot`. Lisez les commentaires au début du `Makefile`. Faites les modifications nécessaires. Faites une sauvegarde de l'original, pour vous prémunir en cas de problèmes. Après compilation, vous devriez obtenir deux exécutables, `nb8390.com` et `nb3c509.com`. C'est l'un de ces programmes que vous devrez exécuter sur la machine sans disque. Il chargera le noyau depuis le serveur de démarrage. Recopiez alors ces deux programmes sur la disquette de démarrage que vous avez créée auparavant.

## 3. Déterminer le programme à utiliser (sur la machine sans disque)

Si vous savez quel composant utilise votre carte Ethernet, c'est facile. Si vous avez un circuit NS8390 ou équivalent, servez vous de `nb8390.com`. Si vous avez un circuit de type 3Com 509, utilisez le programme de démarrage `nb3C509.com`. Si vous ne savez pas, essayez l'un et si vous avez le message ``“`No adapter found`”'', essayez avec l'autre. Si rien ne marche, vous êtes livré à vous-même.

## 4. Démarrer en réseau

Démarrez la station sans disque sans fichiers `config.sys/autoexec.bat`. Essayez d'exécuter le programme de démarrage qui correspond à votre carte Ethernet.

Ma carte Ethernet utilise le mode 16bit WD8013 16bit, j'exécute donc `nb8390.com` :

    C:> cd \netboot
    C:> nb8390

    Boot from Network (Y/N) ?  Y

    BOOTP/TFTP/NFS bootstrap loader     ESC for menu

    Searching for adapter..
    WD8013EBT base 0x0300, memory 0x000D8000, addr 00:40:01:43:26:66

    Searching for server...

La machine sans disque essaye maintenant de trouver un serveur de démarrage. Notez la valeur de `addr` sur l'avant dernière ligne, vous en aurez besoin ensuite. Redémarrez la machine sans disque et modifiez vos fichiers `config.sys` et `autoexec.bat` pour qu'ils fassent automatiquement ce que vous venez de faire à la main. Peut-être avec un menu. Si vous aviez dû utiliser `nb3c509.com` au lieu de `nb8390.com`, les messages seraient identiques. Si vous obtenez le message ``“`No adapter found`”'' après ```Searching for adapter...`'', vérifiez que vous avez défini les bonnes valeurs dans le `Makefile` au moment de compiler.

## 5. Permettre aux systèmes de démarrer via le réseau (sur le serveur)

Vérifiez qu'il y a bien des entrées pour tftp et bootps dans le fichier `/etc/inetd.conf`. Voici le mien :

    tftp   dgram   udp wait    nobody  /usr/libexec/tftpd  tftpd
    #
    # Ajout de qui que vous soyez
    bootps  dgram  udp  wait  root  /usr/libexec/bootpd bootpd /etc/bootptab

Si vous devez modifier le fichier `/etc/inetd.conf`, envoyez ensuite un signal `HUP` à inetd. Pour cela, utilisez la commande `ps -ax | grep inetd | grep -v grep` pour connaître le numéro de processus d'inetd. Une fois que vous l'avez, envoyez lui le signal HUP. Cela se fait avec `kill -HUP <pid>`. Cela obligera inetd à relire ses fichiers de configuration.

Vous avez bien noté la valeur de `addr` dans les messages du programme de démarrage sur la machine sans disque ? C'est maintenant que vous allez en avoir besoin.

Ajoutez une entrée à `/etc/bootptab` (vous devrez peut-être créer ce fichier). Voici à quoi elle doit ressembler :

    altair:\
            :ht=ether:\
            :ha=004001432666:\
            :sm=255.255.255.0:\
            :hn:\
            :ds=199.246.76.1:\
            :ip=199.246.76.2:\
            :gw=199.246.76.1:\
            :vm=rfc1048:

Ce qui, ligne par ligne, signifie :

`altair` | nom du système sans disque, sans nom de domaine
`ht=ether` | type matériel ``ethernet''
`ha=004001432666` | adresse matérielle (le nombre que vous avez noté auparavant)
`sm=255.255.255.0` | masque de sous-réseau
`hn` | dit au serveur de donner au client son nom de machine
`ds=199.246.76.1` | dit au client quel est son serveur de noms de domaine
`ip=199.246.76.2` | dit au client quelle est son adresse IP
`gw=199.246.76.1` | dit au client quelle est sa passerelle par défaut
`vm=...` | laissez cela tel que

> Note : Veillez à bien définir les adresses IP, j'ai inventé celles de l'exemple.

Créez le répertoire `/tftpboot` sur le serveur. Il contiendra les fichiers de configuration pour les systèmes sans disque dont ce sera le serveur de démarrage. Ces fichiers s'appelleront `cfg.<ip>`, où <ip> est l'adresse IP de la machine sans disque. Le fichier de configuration pour ``altair'' est `/tftpboot/cfg.199.246.76.2`. Voici son contenu :

    rootfs 199.246.76.1:/DiskLess/rootfs/altair
    hostname altair.kcis.com

La ligne `hostname altair.kcis.com` indique seulement au système sans disque quel est son nom qualifié.

La ligne `rootfs 199.246.76.1:/DiskLess/rootfs/altair` lui dit où est son système de fichiers racine qui sera monté par NFS.

> Note : Ce système de fichiers racine sera monté en lecture seule par NFS.

L'arborescence de la machine sans disque peut ensuite être remontée pour autoriser les opérations de lecture/écriture.

J'utilise mon 386DX-40 comme terminal X dédié.

Voici l'arborescence d'``altair'' :

/
/bin
/etc
/tmp
/sbin
/dev
/dev/fd
/usr
/var
/var/run

Et la liste des fichiers qu'elle contient :

    -r-xr-xr-x  1 root  wheel  779984 Dec 11 23:44 ./kernel
    -r-xr-xr-x  1 root    bin  299008 Dec 12 00:22 ./bin/sh
    -rw-r--r--  1 root  wheel     499 Dec 15 15:54 ./etc/rc
    -rw-r--r--  1 root  wheel    1411 Dec 11 23:19 ./etc/ttys
    -rw-r--r--  1 root  wheel     157 Dec 15 15:42 ./etc/hosts
    -rw-r--r--  1 root    bin    1569 Dec 15 15:26 ./etc/XF86Config.altair
    -r-x------  1 bin     bin  151552 Jun 10  1995 ./sbin/init
    -r-xr-xr-x  1 bin     bin  176128 Jun 10  1995 ./sbin/ifconfig
    -r-xr-xr-x  1 bin     bin  110592 Jun 10  1995 ./sbin/mount_nfs
    -r-xr-xr-x  1 bin     bin  135168 Jun 10  1995 ./sbin/reboot
    -r-xr-xr-x  1 root    bin   73728 Dec 13 22:38 ./sbin/mount
    -r-xr-xr-x  1 root  wheel    1992 Jun 10  1995 ./dev/MAKEDEV.local
    -r-xr-xr-x  1 root  wheel   24419 Jun 10  1995 ./dev/MAKEDEV

N'oubliez pas d'exécuter `MAKEDEV all` dans le répertoire `dev`.

Voici enfin mon `/etc/rc` pour `altair` :

    #!/bin/sh
    #
    PATH=/bin:/
    export PATH
    #
    # configurer l'interface ``en boucle''
    /sbin/ifconfig lo0 127.0.0.1
    #
    # configurer la carte Ethernet
    /sbin/ifconfig ed0 199.246.76.2 netmask 0xffffff00
    #
    # monter le système de fichiers racine via NFS
    /sbin/mount antares:/DiskLess/rootfs/altair /
    #
    # monter le système de fichiers /usr via NFS
    /sbin/mount antares:/DiskLess/usr /usr
    #
    /usr/X11R6/bin/XF86_SVGA -query antares -xf86config /etc/XF86Config.altair > /dev/null 2>&1
    #
    # Rédemarrer lorsque l'on quitte X
    /sbin/reboot
    #
    # Nous avons planté ...
    exit 1

Vos commentaires et questions sont bienvenus.

Ce document, ainsi que d'autres peut être téléchargé sur ftp.FreeBSD.org/pub/FreeBSD/doc/.

Pour toutes questions à propos de FreeBSD, lisez la documentation avant de contacter <questions@FreeBSD.org>.
Pour les questions sur cette documentation, contactez <doc@FreeBSD.org>.